#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "Gui.h"

Gui::Gui() : BApplication("application/x-vnd.OBOS-GUI")
{
windowCount=0;
}

int Gui::AddWindow (char *name)
{
	windows[windowCount]=new BWindow(BRect (0,0,100,100),name,B_DOCUMENT_WINDOW,0);
}

int Gui::SetTitle (char *name)
{
	windows[windowCount]->SetTitle(name);
}

int Gui::EndWindow (void)
{
	windows[windowCount]->Show();
	windowCount++;
}

int Gui::SetLook(char *name)
{
	if (!strcmp(name,"B_DOCUMENT_WINDOW_LOOK"))
		windows[windowCount]->SetLook(B_DOCUMENT_WINDOW_LOOK);
	else if (!strcmp(name,"B_TITLED_WINDOW_LOOK"))
		windows[windowCount]->SetLook(B_TITLED_WINDOW_LOOK);
	else if (!strcmp(name,"B_FLOATING_WINDOW_LOOK"))
		windows[windowCount]->SetLook(B_FLOATING_WINDOW_LOOK);
	else if (!strcmp(name,"B_MODAL_WINDOW_LOOK"))
		windows[windowCount]->SetLook(B_MODAL_WINDOW_LOOK);
	else if (!strcmp(name,"B_BORDERED_WINDOW_LOOK"))
		windows[windowCount]->SetLook(B_BORDERED_WINDOW_LOOK);
	else if (!strcmp(name,"B_NO_BORDER_WINDOW_LOOK"))
		windows[windowCount]->SetLook(B_NO_BORDER_WINDOW_LOOK);
	else
		;
}

int Gui::SetFeel(char *name)
{
	if (!strcmp(name,"B_NORMAL_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_NORMAL_WINDOW_FEEL);
	else if (!strcmp(name,"B_MODAL_SUBSET_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_MODAL_SUBSET_WINDOW_FEEL);
	else if (!strcmp(name,"B_MODAL_APP_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_MODAL_APP_WINDOW_FEEL);
	else if (!strcmp(name,"B_MODAL_ALL_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_MODAL_ALL_WINDOW_FEEL);
	else if (!strcmp(name,"B_FLOATING_SUBSET_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_FLOATING_SUBSET_WINDOW_FEEL);
	else if (!strcmp(name,"B_FLOATING_APP_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_FLOATING_APP_WINDOW_FEEL);
	else if (!strcmp(name,"B_FLOATING_ALL_WINDOW_FEEL"))
		windows[windowCount]->SetFeel(B_FLOATING_ALL_WINDOW_FEEL);
	else
		;
}

int Gui::SetPulse(char *name)
{
	int len=strlen(name);
	bool bad=false;
	for (int i=0;i<len;i++)
		if (!isdigit(name[i]))
			bad=true;
	if (!bad)
		windows[windowCount]->SetPulseRate(atoi(name));
	else
		;
}

void getFloats(float values[],int count, char *string)
{
	char *temp = new char [strlen(string)+1];
	strcpy(temp,string);
	char *ptr;
	for (int i=0;i<count;i++)
		{
		ptr=strtok(((!i)?temp:NULL),",");
		values[i]=atof(ptr);
		}
	delete (temp);
}

int Gui::SetSizeLimits(char *name)
{
	float size[4];
	getFloats(size,4,name);	
	windows[windowCount]->SetSizeLimits(size[0],size[1],size[2],size[3]);
}


int Gui::SetZoomLimits(char *name)
{
	float size[2];
	getFloats(size,2,name);	
	windows[windowCount]->SetZoomLimits(size[0],size[1]);
}

int Gui::SetPosition(char *name)
{
	float size[2];
	getFloats(size,2,name);	
	windows[windowCount]->MoveTo(size[0],size[1]);
}

int Gui::SetSize(char *name)
{
	float size[2];
	getFloats(size,2,name);	
	windows[windowCount]->ResizeTo(size[0],size[1]);
}

int Gui::SetType(char *name)
{
	if (!strcmp(name,"B_UNTYPED_WINDOW"))
		windows[windowCount]->SetType(B_UNTYPED_WINDOW);
	else if (!strcmp(name,"B_MODAL_WINDOW"))
		windows[windowCount]->SetType(B_MODAL_WINDOW);
	else if (!strcmp(name,"B_BORDERED_WINDOW"))
		windows[windowCount]->SetType(B_BORDERED_WINDOW);
	else if (!strcmp(name,"B_TITLED_WINDOW"))
		windows[windowCount]->SetType(B_TITLED_WINDOW);
	else if (!strcmp(name,"B_DOCUMENT_WINDOW"))
		windows[windowCount]->SetType(B_DOCUMENT_WINDOW);
	else if (!strcmp(name,"B_FLOATING_WINDOW"))
		windows[windowCount]->SetType(B_FLOATING_WINDOW);
	else 
		;
}

int Gui::SetWorkspace(char *name)
{
	if (!strcmp(name,"B_CURRENT_WORKSPACE"))
		windows[windowCount]->SetWorkspaces( B_CURRENT_WORKSPACE );
	else if (!strcmp(name,"B_ALL_WORKSPACES"))
		windows[windowCount]->SetWorkspaces(B_ALL_WORKSPACES);
	else
		{
		int len=strlen(name);
		bool bad=false;
		for (int i=0;i<len;i++)
			if (!isdigit(name[i]))
				bad=true;
		if (!bad)
			windows[windowCount]->SetWorkspaces(atoi(name));
		else
			;
		}
}

uint32 stringToFlag(char *name)
{
	if (!strcmp(name,"B_NOT_MOVABLE")) return  B_NOT_MOVABLE;
	else if (!strcmp(name,"B_NOT_CLOSABLE")) return  B_NOT_CLOSABLE;
	else if (!strcmp(name,"B_NOT_ZOOMABLE")) return  B_NOT_ZOOMABLE ;
	else if (!strcmp(name,"B_NOT_MINIMIZABLE")) return  B_NOT_MINIMIZABLE ;
	else if (!strcmp(name,"B_NOT_H_RESIZABLE")) return  B_NOT_H_RESIZABLE ;
	else if (!strcmp(name,"B_NOT_V_RESIZABLE")) return  B_NOT_V_RESIZABLE ;
	else if (!strcmp(name,"B_NOT_RESIZABLE")) return  B_NOT_RESIZABLE ;
	else if (!strcmp(name,"B_OUTLINE_RESIZE")) return B_OUTLINE_RESIZE ;
	else if (!strcmp(name,"B_WILL_ACCEPT_FIRST_CLICK")) return  B_WILL_ACCEPT_FIRST_CLICK ;
	else if (!strcmp(name,"B_AVOID_FRONT")) return B_AVOID_FRONT ;
	else if (!strcmp(name,"B_AVOID_FOCUS")) return B_AVOID_FOCUS ;
	else if (!strcmp(name,"B_NO_WORKSPACE_ACTIVATION")) return B_NO_WORKSPACE_ACTIVATION ;
	else if (!strcmp(name,"B_NOT_ANCHORED_ON_ACTIVATE")) return B_NOT_ANCHORED_ON_ACTIVATE ;
	else if (!strcmp(name,"B_ASYNCHRONOUS_CONTROLS")) return  B_ASYNCHRONOUS_CONTROLS ;
	else if (!strcmp(name,"B_QUIT_ON_WINDOW_CLOSE")) return B_QUIT_ON_WINDOW_CLOSE ;
	else ;
	return 0; // shouldn't ever need
}

int Gui::SetFlags(char *name)
{
	uint32 value=0;
	for (char *temp= strtok(name,"|");temp;temp=strtok(NULL,"|"))
		value|=stringToFlag(name);
	windows[windowCount]->SetFlags(value);
}
