%{
#include <stdio.h>
#include "Gui.h"
extern char *yytext;
extern FILE *yyin;
Gui myGui;
int yyerror(char *s);
int yylex(void);
%}


%token NEW WINDOW NAME EOS EQUALS LABEL END LOOK FEEL PULSERATE SIZELIMITS ZOOMLIMITS TYPE WORKSPACE 
%token FLAGS POSITION SIZE
%%
commands: | commands command 
command: EOS | NAME {myGui.AddWindow(yytext);} EQUALS NEW WINDOW EOS options end
options: | options option
option: EOS | LABEL NAME {myGui.SetTitle(yytext);} EOS  |
		LOOK NAME {myGui.SetLook(yytext);} EOS |
		FEEL NAME {myGui.SetFeel(yytext);} EOS |
		PULSERATE NAME {myGui.SetPulse(yytext);} EOS |
		SIZELIMITS NAME {myGui.SetSizeLimits(yytext);} EOS |
		ZOOMLIMITS NAME {myGui.SetZoomLimits(yytext);} EOS |
		TYPE NAME {myGui.SetType(yytext);} EOS |
		FLAGS NAME {myGui.SetFlags(yytext);} EOS |
		POSITION NAME {myGui.SetPosition(yytext);} EOS |
		SIZE NAME {myGui.SetSize(yytext);} EOS |
		WORKSPACE NAME {myGui.SetWorkspace(yytext);} EOS 


end: END {myGui.EndWindow();}
%%

int main(int argc,char **argv)
{
	yyparse();
	myGui.Run();
	return 0;
}

int yyerror(char *s)
{
printf ("%s\n",s);
}
